﻿#include "StdAfx.h"
#include "NeMessenger.h"
#include "ClientConfig.h"
#include "CommonFunction.h"
#include "NeMessengerDlg.h"
#include "StickerItem.h"

CClientConfig::CClientConfig(void)
{
	m_nMemoMaxUser=50;
	m_vecFunction.clear();
	m_strFunctionList = _T("");
	m_nCopyNameDate = 0;
	m_nChatDisplayType = 0;
	m_bOpenFolderAfterDownload = TRUE;

    //init for uninitialized value( just set 0, and LoadClientConfig)
    m_nAutoStart = 0;
    m_nAutoMessageView = 0;
    m_nFavoriteTray = 0;
    m_nGMT = 0;
    m_nLanguage = 0;

    m_nAutoAwayState = 0;
    m_nAutoAwayTime = 0;
    m_nMemoAlarmType = 0;
    m_nNameDisplayType = 0;
    
    m_nAddInfoPosition = 0;
    m_nAddInfoJob = 0;
    m_nAddInfoPart = 0;
    m_nAddInfoID = 0;
    m_nAddInfoCellPhone = 0;
    m_nAddInfoTel = 0;
    m_nAddInfoExtension = 0;
    m_nAddEmail = 0;
    m_nAutoLogin = 0;
    
    m_nNoteCloseType = 0;
    m_nNoteRecovery = 0;
    m_nAllSound = 0;
    m_nNoteSound = 0;
    m_nChatSound = 0;
    m_nTraySound = 0;
    m_nSystemSound = 0;
    m_bSoundNotOnline = 0;
    m_bNotifyOnNews = 0;
    m_bNotifyOnMailOrSMS = 0;
    m_bShieldMobile = 0;
    m_nNeverShowCloseChatDlgMobile = 0;

    m_nNoticeViewID = 0;
    m_nNoticeViewCount = 0;
    m_nUpdateNoticeViewCount = 0;
    m_nTinyWebServer = 0;
}

CClientConfig::~CClientConfig(void)
{
}


void CClientConfig::DelOutLinkList(size_t nIndex)
{
	OUTLINK_MAP::iterator iter =m_mapOutLinkList.find(nIndex);
	if(iter != m_mapOutLinkList.end())
	{
		m_mapRemoveOutLinkList.insert(std::make_pair(iter->first,iter->second));
		m_mapOutLinkList.erase(iter);
		
	}
}

void CClientConfig::AddOutLinkList(size_t nIndex)
{
	OUTLINK_MAP::iterator iter = m_mapRemoveOutLinkList.find(nIndex);
	if(iter != m_mapRemoveOutLinkList.end())
	{
		m_mapOutLinkList.insert(std::make_pair(iter->first,iter->second));
		m_mapRemoveOutLinkList.erase(iter);
		
	}
}

void CClientConfig::LoadOutLinkList(const std::vector<NE_OUTLINK_DATA> &vecOutLinkList)
{
	if (vecOutLinkList.size() <= 0)
		return;

	m_mapOutLinkList.clear();
	m_mapRemoveOutLinkList.clear();

	std::vector<NE_OUTLINK_DATA>::const_iterator iter = vecOutLinkList.begin();
	for(; iter != vecOutLinkList.end(); iter++)
	{
		NE_OUTLINK_DATA sData;
		sData.nLinkID = (*iter).nLinkID;
		sData.strTitle = (*iter).strTitle;
		sData.strLinkURL = (*iter).strLinkURL;
		sData.strIconURL = (*iter).strIconURL;
		TRACE(_T("Link ID = %d , tlt= %s url = %s  icon=%s\n"), (*iter).nLinkID, (*iter).strTitle.c_str(), (*iter).strLinkURL.c_str(), (*iter).strIconURL.c_str());
		m_mapOutLinkList.insert(std::make_pair(sData.nLinkID,sData));
	}

	//GETCONFIG()에 있는 값을 m_mapAllOutLinkList에서 가져와서 Selectedmap에 채워 넣어준다.  
	CString strSubText;
	int i=0;
	while(1)
	{
		if( !AfxExtractSubString(strSubText, GET_CONFIG()->m_strOutLink, i++, ';') )
			break;

		if (strSubText==L"")
			break;
		OUTLINK_MAP::iterator iter = m_mapOutLinkList.find(_ttoi(strSubText));
		if(iter != m_mapOutLinkList.end())
		{
			m_mapRemoveOutLinkList.insert(std::make_pair(iter->first, iter->second));
			m_mapOutLinkList.erase(iter);
		}
	}
}

CString CClientConfig::GetOutLinkString()
{
	CString strLinkString;
	OUTLINK_MAP::iterator iter = m_mapRemoveOutLinkList.begin();
	for(; iter != m_mapRemoveOutLinkList.end(); iter++)
	{
		strLinkString.AppendFormat(_T("%d;"),iter->first);
	}
	return strLinkString;
}


void CClientConfig::LoadExpandBuddyGroup()
{
	m_mapExpandBuddyGroup.clear();
	CString strSubText;
	int i=0;
	while(1)
	{
		if( !AfxExtractSubString(strSubText, GET_CONFIG()->m_strExpandBuddy, i++, ';') )
			break;

		if (strSubText==L"")
			break;
	/*	std::map<int,int>::iterator iter = m_mapExpandBuddyGroup.find(_ttoi(strSubText));
		if(iter != m_mapExpandBuddyGroup.end())
		{*/
		m_mapExpandBuddyGroup.insert(std::make_pair(_ttoi(strSubText), _ttoi(strSubText)));
		//}
	}
}
void CClientConfig::SaveExpandBuddyGroup()
{
	CString strSavePath;
	strSavePath = GetClientConfigPath();
	WritePrivateProfileString(_T("ClientConfig"),_T("ExpandBuddyGroup"),GetExpandBuddyGroupString(),strSavePath);

}
CString CClientConfig::GetExpandBuddyGroupString()
{
	CString strExpandBuddyGroupString;
	std::map<int, int>::iterator iter = m_mapExpandBuddyGroup.begin();
	for(; iter != m_mapExpandBuddyGroup.end(); iter++)
	{
		strExpandBuddyGroupString.AppendFormat(_T("%d;"),iter->first);
	}
	return strExpandBuddyGroupString;
}

CString CClientConfig::GetRecentChatDataPath(CString strRoomId)
{
	CString strDir, strDir2;
	strDir.Format(_T("%s\\recentchat"), GET_APP()->GetAppDataDir());
	strDir2.Format(_T("%s\\recentchat\\%s"), GET_APP()->GetAppDataDir(), strRoomId);
	if(_waccess(strDir, 0) == -1)
		_wmkdir(strDir);

	if(_waccess(strDir2, 0) == -1)
		_wmkdir(strDir2);

	CString	strRecentChatPath;
	strRecentChatPath.Format(_T("%s\\recentchat\\%s\\abnormal_data.dat"), GET_APP()->GetAppDataDir(), strRoomId);
	return strRecentChatPath;
}
CString CClientConfig::GetAbnormalDataPath(CString strRoomId, CString strUserId)
{
	CString strDir, strDir2, strDir3;
	strDir.Format(_T("%s\\abnormal"), GET_APP()->GetAppDataDir());
	strDir2.Format(_T("%s\\abnormal\\%s"), GET_APP()->GetAppDataDir(), strUserId);
	strDir3.Format(_T("%s\\abnormal\\%s\\%s"), GET_APP()->GetAppDataDir(), strUserId, strRoomId);
	if(_waccess(strDir, 0) == -1)
		_wmkdir(strDir);

	if(_waccess(strDir2, 0) == -1)
		_wmkdir(strDir2);

	if(_waccess(strDir3, 0) == -1)
		_wmkdir(strDir3);
	CString	strAbnormalDataPath;
	strAbnormalDataPath.Format(_T("%s\\abnormal\\%s\\%s\\abnormal_data.dat"), GET_APP()->GetAppDataDir(), strUserId, strRoomId);
	return strAbnormalDataPath;
}

CString CClientConfig::GetAbnormalDataDir(CString strRoomId, CString strUserId)
{
	CString strDir, strDir2, strDir3;
	strDir.Format(_T("%s\\abnormal"), GET_APP()->GetAppDataDir());
	strDir2.Format(_T("%s\\abnormal\\%s"), GET_APP()->GetAppDataDir(), strUserId);
	strDir3.Format(_T("%s\\abnormal\\%s\\%s"), GET_APP()->GetAppDataDir(), strUserId, strRoomId);
	if(_waccess(strDir, 0) == -1)
		_wmkdir(strDir);

	if(_waccess(strDir2, 0) == -1)
		_wmkdir(strDir2);

	if(_waccess(strDir3, 0) == -1)
		_wmkdir(strDir3);
	CString	strAbnormalDataPath;
	strAbnormalDataPath.Format(_T("%s\\abnormal\\%s\\%s"), GET_APP()->GetAppDataDir(), strUserId, strRoomId);
	return strAbnormalDataPath;
}


CString CClientConfig::GetClientConfigPath()
{
	CString strClientConfigFilePath;
	strClientConfigFilePath.Format(_T("%s\\client_config.ini"), GET_APP()->GetAppDataDir());

	return strClientConfigFilePath;
}

CString CClientConfig::GetTinyWebServerConfigPath()
{
	CString strTinyWebServerConfigPath;
	strTinyWebServerConfigPath.Format(_T("%s\\tinyServer_config.ini"), GET_APP()->GetAppDataDir());

	return strTinyWebServerConfigPath;
}



void CClientConfig::SaveClientConfig()
{
	CString strValue;
	CString strSavePath;
	CString strDB;

	strSavePath = GetClientConfigPath();

	strValue.Format(_T("%d"),m_nAutoStart);
	WritePrivateProfileString(_T("ClientConfig"),_T("AutoStart"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAutoMessageView);
	WritePrivateProfileString(_T("ClientConfig"),_T("AutoMessageView"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nFavoriteTray);
	WritePrivateProfileString(_T("ClientConfig"),_T("FavoriteTray"), strValue,strSavePath);  // Messenger config

	strValue.Format(_T("%d"),m_nGMT);
	WritePrivateProfileString(_T("ClientConfig"),_T("GMT"), strValue,strSavePath);

	strValue.Format(_T("%d"), m_nLanguage);
	WritePrivateProfileString(_T("ClientConfig"),_T("Language"), strValue,strSavePath);

	WritePrivateProfileString(_T("ClientConfig"),_T("RecvFolder"), m_strRecvFolder,strSavePath);

	strValue.Format(_T("%d"),m_bOpenFolderAfterDownload);
	WritePrivateProfileString(_T("ClientConfig"),_T("OpenFolderAfterDownload"), strValue, strSavePath);

	WritePrivateProfileString(_T("ClientConfig"),_T("NickName"), m_strNickName,strSavePath);

	strValue.Format(_T("%d"),m_nAutoAwayState);
	WritePrivateProfileString(_T("ClientConfig"),_T("AutoAwayState"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAutoAwayTime);
	WritePrivateProfileString(_T("ClientConfig"),_T("AutoAwayTime"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nMemoAlarmType);
	WritePrivateProfileString(_T("ClientConfig"),_T("MemoAlarmType"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nNameDisplayType);
	WritePrivateProfileString(_T("ClientConfig"),_T("NameDisplayType"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoPosition);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoPosition"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoJob);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoJob"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoPart);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoPart"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoID);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoID"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoCellPhone);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoCellPhone"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoTel);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoTel"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddInfoExtension);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddInfoExtension"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nAddEmail);
	WritePrivateProfileString(_T("ClientConfig"),_T("AddEmail"), strValue,strSavePath);

	WritePrivateProfileString(_T("ClientConfig"),_T("OutLink"),	GetOutLinkString(),strSavePath);

	strValue.Format(_T("%d"), m_nAutoLogin);
	WritePrivateProfileString(_T("ClientConfig"), _T("AutoLogin"), strValue, strSavePath);

	WritePrivateProfileString(_T("ClientConfig"), _T("SIP"), m_strSIP, strSavePath);

	WritePrivateProfileString(_T("ClientConfig"), _T("SMTS"), m_strSMTS, strSavePath);

	//WritePrivateProfileString(_T("ClientConfig"), _T("Lang"), m_strLang, strSavePath);

	strValue.Format(_T("%d"),m_nCopyNameDate);
	WritePrivateProfileString(_T("ClientConfig"),_T("CopyNameDate"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nNoteCloseType);
	WritePrivateProfileString(_T("ClientConfig"),_T("NoteClose"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nNoteRecovery);
	WritePrivateProfileString(_T("ClientConfig"),_T("NoteRecovery"), strValue,strSavePath);
	
	strValue.Format(_T("%d"),m_bSoundNotOnline);
	WritePrivateProfileString(_T("ClientConfig"),_T("OfflineSound"), strValue,strSavePath); // Messenger config

	strValue.Format(_T("%d"),m_bNotifyOnNews);
	WritePrivateProfileString(_T("ClientConfig"),_T("NotifyOnNews"), strValue,strSavePath); // Messenger config

	strValue.Format(_T("%d"),m_bNotifyOnMailOrSMS);
	WritePrivateProfileString(_T("ClientConfig"),_T("MailNoteNotify"), strValue,strSavePath); // Messenger config

	strValue.Format(_T("%d"),m_bShieldMobile);
	WritePrivateProfileString(_T("ClientConfig"),_T("MobileDumbOnPCUsed"), strValue,strSavePath); // Messenger config

	strValue.Format(_T("%d"),m_nAllSound);
	WritePrivateProfileString(_T("ClientConfig"),_T("AllSound"), strValue,strSavePath);  //sound on

	strValue.Format(_T("%d"),m_nNoteSound);
	WritePrivateProfileString(_T("ClientConfig"),_T("NoteSound"), strValue,strSavePath);  //note sound off

	strValue.Format(_T("%d"),m_nChatSound);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatSound"), strValue,strSavePath); // chat sound off

	strValue.Format(_T("%d"),m_nTraySound);
	WritePrivateProfileString(_T("ClientConfig"),_T("TraySound"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nSystemSound);
	WritePrivateProfileString(_T("ClientConfig"),_T("SystemSound"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nChatDisplayType);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatDisplayType"), strValue,strSavePath);


	strValue.Format(_T("%d"),m_nNoticeViewID);
	WritePrivateProfileString(_T("ClientConfig"),_T("NoticeViewID"), strValue,strSavePath);

	strValue.Format(_T("%d"),m_nNoticeViewCount);
	WritePrivateProfileString(_T("ClientConfig"),_T("NoticeViewCount"), strValue,strSavePath);

	WritePrivateProfileString(_T("ClientConfig"), _T("UpdateNoticeURL"), m_strUpdateNoticeURL, strSavePath);

	strValue.Format(_T("%d"),m_nUpdateNoticeViewCount);
	WritePrivateProfileString(_T("ClientConfig"),_T("UpdateNoticeViewCount"), strValue,strSavePath);

}

BOOL CClientConfig::LoadClientConfig()
{
	CString strLoadPath;
	strLoadPath=_T("");
	strLoadPath = GetClientConfigPath();

	TCHAR buf[1024]={NULL,};
	m_nAutoStart = 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AutoStart"),1,strLoadPath);

	m_nAutoMessageView = 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AutoMessageView"),0,strLoadPath);

	m_nFavoriteTray = 
		GetPrivateProfileInt(_T("ClientConfig"),_T("FavoriteTray"),0,strLoadPath);

	m_nGMT = 
		GetPrivateProfileInt(_T("ClientConfig"),_T("GMT"),26,strLoadPath);
	m_nLanguage =
		GetPrivateProfileInt(_T("ClientConfig"),_T("Language"),0,strLoadPath);

	memset(buf, 0x00, sizeof(buf));
	GetPrivateProfileString(_T("ClientConfig"), _T("SMTS"), _T(""), buf, _countof(buf), strLoadPath);
	m_strSMTS = (LPCTSTR)buf;
	memset(buf, 0x00, sizeof(buf));

	TCHAR szDefaultSavePath[MAX_PATH] = {0};

	GetPrivateProfileString(_T("ClientConfig"), _T("RecvFolder"), _T(""), szDefaultSavePath, _countof(szDefaultSavePath), strLoadPath);
	
	CString strLocalSMTS = m_strSMTS;
	if (strLocalSMTS.IsEmpty())
	{
		strLocalSMTS = TEXT("nhncorp/nts");
	}
	int nPosCorp = strLocalSMTS.Find(_T("/"));
	if (nPosCorp > 0)
	{
		CString strDecCorp = strLocalSMTS.Left(nPosCorp);
		if (strDecCorp.CompareNoCase(_T("nhncorp")) == 0)
		{
			// nhncorp - "\My Documents\Ntalk"
			if(lstrlen(szDefaultSavePath) == 0){
				SHGetSpecialFolderPath(NULL, szDefaultSavePath, CSIDL_MYDOCUMENTS , TRUE);
				PathAppend(szDefaultSavePath, _T("Ntalk biz\\Download"));
			}
			
		}
		else if (strDecCorp.CompareNoCase(_T("hanatour")) == 0)
		{
			//Modify by Sevin for bts:NTALKCL-1233
			//hanatour - "\HanaTour\NTalk\Download"
// 			if(lstrlen(szDefaultSavePath) == 0){
// 				StringCchCopy(szDefaultSavePath, _countof(szDefaultSavePath), 
// 					_T("C:\\HanaTour\\NTalk\\Download"));
// 			}
			if(lstrlen(szDefaultSavePath) == 0){
				SHGetSpecialFolderPath(NULL, szDefaultSavePath, CSIDL_MYDOCUMENTS , TRUE);
				PathAppend(szDefaultSavePath, _T("Ntalk biz\\Download"));
			}
		}
	}

	
	CString strDB;
	strDB.Format(_T("strLoadPath load state= %s "),strLoadPath);
	OutputDebugString(strDB);

	m_bOpenFolderAfterDownload = 
		(BOOL)GetPrivateProfileInt(_T("ClientConfig"),_T("OpenFolderAfterDownload"), 1, strLoadPath);

	m_strRecvFolder =(LPCTSTR)szDefaultSavePath; //buf;
	// The m_strRecvFolder is fixed to "C:\Users\nhn\Documents\Ntalk biz\Download"
	memset(buf, 0, sizeof(buf));

	CString strString;
	strString.LoadString(IDS_STRING177);
	GetPrivateProfileString(_T("ClientConfig"), _T("NickName"), strString, buf, 1024, strLoadPath);
	m_strNickName = (LPCTSTR)buf;
	memset(buf, 0, sizeof(buf));

	 m_nAutoAwayState= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AutoAwayState"),0,strLoadPath);

	 m_nAutoAwayTime= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AutoAwayTime"),5,strLoadPath);

	 m_nMemoAlarmType= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("MemoAlarmType"),1,strLoadPath);

	 m_nNameDisplayType= 0;
		//GetPrivateProfileInt(_T("ClientConfig"),_T("NameDisplayType"),1,strLoadPath);

	 m_nAddInfoPosition= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoPosition"),0,strLoadPath);

	 m_nAddInfoJob= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoJob"),0,strLoadPath);

	 m_nAddInfoPart= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoPart"),0,strLoadPath);

	 m_nAddInfoID = 
		 GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoID"),0,strLoadPath);

	m_nAddInfoCellPhone = 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoCellPhone"),0,strLoadPath);

	 m_nAddInfoTel= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoTel"),0,strLoadPath);

	 m_nAddInfoExtension= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddInfoExtension"),0,strLoadPath);

	 m_nAddEmail= 
		GetPrivateProfileInt(_T("ClientConfig"),_T("AddEmail"),0,strLoadPath);

	 GetPrivateProfileString(_T("ClientConfig"),_T("OutLink"),_T(""),
		 buf,1024,strLoadPath);
	 m_strOutLink =(LPCTSTR)buf;
	 memset(buf, 0, sizeof(buf));


	 TCHAR bufExpandGroup[4096]={NULL,};

	 GetPrivateProfileString(_T("ClientConfig"),_T("ExpandBuddyGroup"),_T(""), bufExpandGroup,4096,strLoadPath);
	 m_strExpandBuddy =(LPCTSTR)bufExpandGroup;
	 memset(bufExpandGroup, 0, sizeof(bufExpandGroup));

	LoadExpandBuddyGroup();

	m_nAutoLogin = GetPrivateProfileInt(_T("ClientConfig"), _T("AutoLogin"), 0, strLoadPath);

	GetPrivateProfileString(_T("ClientConfig"), _T("SIP"), _T(""), buf, 1024, strLoadPath);
	m_strSIP = (LPCTSTR)buf;
	memset(buf, 0x00, sizeof(buf));
	
	m_nCopyNameDate = GetPrivateProfileInt(_T("ClientConfig"), _T("CopyNameDate"), 1, strLoadPath);
	m_nNoteCloseType = 1;//GetPrivateProfileInt(_T("ClientConfig"), _T("NoteClose"), 1, strLoadPath);	// Modify by sevin for bts:NTALKCL-1013
	m_nNoteRecovery = 0;
	m_nAllSound = GetPrivateProfileInt(_T("ClientConfig"), _T("AllSound"), 1, strLoadPath);
	m_nNoteSound = GetPrivateProfileInt(_T("ClientConfig"), _T("NoteSound"), 1, strLoadPath);
	m_nChatSound = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatSound"), 1, strLoadPath);
	m_nTraySound = GetPrivateProfileInt(_T("ClientConfig"), _T("TraySound"), 1, strLoadPath);
	m_nSystemSound = GetPrivateProfileInt(_T("ClientConfig"), _T("SystemSound"), 1, strLoadPath);

    
	m_bSoundNotOnline = GetPrivateProfileInt(_T("ClientConfig"), _T("OfflineSound"), 1, strLoadPath);
	m_bNotifyOnNews = GetPrivateProfileInt(_T("ClientConfig"), _T("NotifyOnNews"), 1, strLoadPath);
	m_bNotifyOnMailOrSMS = GetPrivateProfileInt(_T("ClientConfig"), _T("MailNoteNotify"), 1, strLoadPath);
	m_bShieldMobile = GetPrivateProfileInt(_T("ClientConfig"), _T("MobileDumbOnPCUsed"), 1, strLoadPath);

	m_nNeverShowCloseChatDlgMobile = GetPrivateProfileInt(_T("ClientConfig"), _T("NeverShow_CloseChatDlgWithMobile"), 0, strLoadPath);

	m_nChatDisplayType = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatDisplayType"), 0, strLoadPath);

	m_nNoticeViewCount = GetPrivateProfileInt(_T("ClientConfig"), _T("NoticeViewCount"), 0, strLoadPath);

	m_nNoticeViewID = GetPrivateProfileInt(_T("ClientConfig"), _T("NoticeViewID"), 0, strLoadPath);

	GetPrivateProfileString(_T("ClientConfig"), _T("UpdateNoticeURL"), _T(""), buf, 1024, strLoadPath);
	m_strUpdateNoticeURL = (LPCTSTR)buf;
	memset(buf, 0x00, sizeof(buf));
	m_nUpdateNoticeViewCount = GetPrivateProfileInt(_T("ClientConfig"), _T("UpdateNoticeViewCount"), 0, strLoadPath);


	return TRUE;
}

BOOL CClientConfig::LoadTinyWebServerConfig()
{

	CString strLoadPath;
	strLoadPath=_T("");
	strLoadPath = GetTinyWebServerConfigPath();

	TCHAR buf[1024]={NULL,};

	m_nTinyWebServer = GetPrivateProfileInt(_T("TinyWebServerConfig"),_T("AutoStart"),0,strLoadPath);

	GetPrivateProfileString(_T("TinyWebServerConfig"), _T("WebServerIP"), _T("127.0.0.1"), buf, 1024, strLoadPath);
	m_strWebServerIP = (LPCTSTR)buf;
	memset(buf, 0x00, sizeof(buf));

	GetPrivateProfileString(_T("TinyWebServerConfig"), _T("WebServerPort"), _T("8808"), buf, 1024, strLoadPath);
	m_strWebServerPort = (LPCTSTR)buf;
	memset(buf, 0x00, sizeof(buf));

	TCHAR folderPath[2048];
	::GetModuleFileName(NULL,folderPath,2048); 
	CString str(folderPath);
	m_strWebServerRoot=str.Mid(0,str.ReverseFind(_T('\\')));
	return TRUE;

}
void CClientConfig::SaveTinyWebServerConfig()
{
	CString strValue;
	CString strSavePath;
	strSavePath = GetTinyWebServerConfigPath();
}


void CClientConfig::AppAutoStart(BOOL bIsAutostart)
{
	TCHAR folderPath[2048];
	::GetModuleFileName(NULL,folderPath,2048); 
	CString str(folderPath);
	str=str.Mid(0,str.ReverseFind(_T('\\')));
	str.AppendFormat(_T("\\Ntalkbiz.exe"));
	if (bIsAutostart)
	{
		reg_WriteString(HKEY_CURRENT_USER,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run"),
			_T("Ntalkbiz"),(TCHAR*)(LPCTSTR)str);
	}
	else
	{
		reg_DeleteValue(HKEY_CURRENT_USER,_T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run"),
			_T("Ntalkbiz"));
	}
}


void CClientConfig::SetFunctionList(LPCTSTR strFunctionList)
{
	m_strFunctionList = strFunctionList;

	m_vecFunction.clear();
	SplitString(strFunctionList, _T('|'), m_vecFunction);		
// 	for (int i = 0; i < m_vecFunction.size(); i++)
// 	{
// 		if (m_vecFunction[i].Compare(_T("UI_04")) == 0)
// 		{
// 			m_vecFunction[i] = _T(" ");
// 			break;
// 		}
// 	}
}

int CClientConfig::SetMyAuth(GT_MY_USER_DATA *pMyInfo)
{
	SetFunctionList(pMyInfo->sMyPage.strFunction);
	int nAuthCount = 0;

	// 조직도 권한
	if (EnableFunction(_T("ME_02")))
	{
		m_legacyBtnInfo.bInfoWorkOrg = TRUE;
		nAuthCount++;
	}
	else
		m_legacyBtnInfo.bInfoWorkOrg = FALSE;

	// 쪽지 권한
	if (StrStr(pMyInfo->sMyPage.strServiceList, _T("note_web")) == NULL)
		m_legacyBtnInfo.bInfoNote = FALSE;
	else
	{
		m_legacyBtnInfo.bInfoNote = TRUE;
		nAuthCount++;
	}

	// 메일 권한
	if (StrStr(pMyInfo->sMyPage.strServiceList, _T("mail_web")) == NULL)
		m_legacyBtnInfo.bInfoMail = FALSE;
	else 
	{
		m_legacyBtnInfo.bInfoMail = TRUE;
		nAuthCount++;
	}

	CString strLegacyAuth = pMyInfo->sMyPage.strLagacyLink;		// 12:결재|13:VOC|14:설문|20:하나인|21:하나샘

	// 결재
	if (strLegacyAuth.Find(_T("12:")) == -1)
		m_legacyBtnInfo.bInfoSign = FALSE;
	else 
	{
		m_legacyBtnInfo.bInfoSign = TRUE;
		nAuthCount++;
	}

	// VOC
	if (strLegacyAuth.Find(_T("13:")) == -1)
		m_legacyBtnInfo.bInfoVOC = FALSE;
	else 
	{
		m_legacyBtnInfo.bInfoVOC = TRUE;
		nAuthCount++;
	}

	// 설문
	if (strLegacyAuth.Find(_T("14:")) == -1)
		m_legacyBtnInfo.bInfoSurvay = FALSE;
	else 
	{
		m_legacyBtnInfo.bInfoSurvay = TRUE;
		nAuthCount++;
	}

	// 하나인
	if (strLegacyAuth.Find(_T("20:")) == -1)
		m_legacyBtnInfo.bInfoIN = FALSE;
	else 
	{
		m_legacyBtnInfo.bInfoIN = TRUE;
		nAuthCount++;
	}

	// 하나샘
	if (strLegacyAuth.Find(_T("21:")) == -1)
		m_legacyBtnInfo.bInfoSAM = FALSE;
	else 
	{
		m_legacyBtnInfo.bInfoSAM = TRUE;
		nAuthCount++;
	}

	// Chat link button enabled only nhncorp tenant.
	if (g_stNtalkInfo.strCorp.CompareNoCase(_T("nhncorp")) == 0)
		m_legacyBtnInfo.bInfoChat = TRUE;
	else
		m_legacyBtnInfo.bInfoChat = FALSE;

	return nAuthCount;
}

CString CClientConfig::GetFunctionList()
{
	return m_strFunctionList;
}

BOOL CClientConfig::EnableFunction(LPCTSTR strFunction)
{	
// 	if(wcscmp(strFunction, _T("ME_02")) == 0)
// 		return FALSE;	
	
	std::vector<CString>::iterator iter = std::find(m_vecFunction.begin(), m_vecFunction.end(), strFunction);
	if(iter != m_vecFunction.end())
	{
		return TRUE;
	}

	return FALSE;
}

bool CClientConfig::SaveChatFont(CHARFORMAT2* pCf)
{
	CString strSavePath = GetClientConfigPath();
	CString strValue = _T("");

	if (pCf->cbSize <= 0)
		return false;

	strValue.Format(_T("%u"), pCf->dwMask);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_dwMask"), strValue, strSavePath);

	strValue.Format(_T("%u"), pCf->dwEffects);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_dwEffects"), strValue, strSavePath);

	strValue.Format(_T("%d"), pCf->yHeight);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_yHeight"), strValue, strSavePath);

	strValue.Format(_T("%d"), pCf->yOffset);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_yOffset"), strValue, strSavePath);

	strValue.Format(_T("%u"), pCf->crTextColor);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_crTextColor"), strValue, strSavePath);

	strValue.Format(_T("%d"), pCf->bCharSet);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_bCharSet"), strValue, strSavePath);

	strValue.Format(_T("%d"), pCf->bPitchAndFamily);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_bPitchAndFamily"), strValue, strSavePath);

	strValue.Format(_T("%d"), pCf->lcid);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_lcid"), strValue, strSavePath);

	strValue.Format(_T("%s"), pCf->szFaceName);
	WritePrivateProfileString(_T("ClientConfig"),_T("ChatFont_szFaceName"), strValue, strSavePath);

	return true;
}

bool CClientConfig::LoadChatFont(CHARFORMAT2* pCf)
{
	CString strLoadPath = GetClientConfigPath();
	TCHAR buf[LF_FACESIZE] = {NULL,};

	pCf->dwMask = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_dwMask"), 0, strLoadPath);

	if (pCf->dwMask == 0)
		return false;

	pCf->dwEffects = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_dwEffects"), 0, strLoadPath);
	pCf->yHeight = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_yHeight"), 0, strLoadPath);

	if (pCf->yHeight == 0)
		return false;

	pCf->yOffset = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_yOffset"), 0, strLoadPath);
	pCf->crTextColor = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_crTextColor"), 0, strLoadPath);
	pCf->bCharSet = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_bCharSet"), 0, strLoadPath);
	pCf->bPitchAndFamily = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_bPitchAndFamily"), 0, strLoadPath);
	pCf->lcid = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatFont_lcid"), 1042, strLoadPath);

	GetPrivateProfileString(_T("ClientConfig"), _T("ChatFont_szFaceName"), g_defaultFontFaceName, buf, LF_FACESIZE, strLoadPath);
	_tcscpy_s(pCf->szFaceName, LF_FACESIZE, buf);

	return true;
}

bool CClientConfig::SaveBool(CString strKey, BOOL bValue)
{
	CString strSavePath = GetClientConfigPath();
	CString strValue = _T("");

	strValue.Format(_T("%d"), bValue);
	WritePrivateProfileString(_T("ClientConfig"), strKey, strValue, strSavePath);

	return true;
}

int CClientConfig::GetChatAlignHelpMsgShowingCount()
{
	CString strLoadPath = GetClientConfigPath();
	//TCHAR buf[LF_FACESIZE] = {NULL,};

	int nCount = GetPrivateProfileInt(_T("ClientConfig"), _T("ChatAlignHelpMsgCount"), 0, strLoadPath);

	// 바로 카운트 +1을 해서 저장한다.
	CString strValue;
	if (nCount >= 5)
		strValue.Format(_T("%d"), 5);
	else
		strValue.Format(_T("%d"), nCount + 1);

	WritePrivateProfileString(_T("ClientConfig"),_T("ChatAlignHelpMsgCount"), strValue, strLoadPath);

	return nCount;
}
/*
BOOL CClientConfig::LoadStickerGroupInfo(std::vector<CStickerGroupItem*> *vecGroup)
{

	CString stringLine[4] = {_T("01:tab\\btn_chat_talk_icon_01.png"),_T("02:tab\\btn_chat_talk_icon_02.png"),
		_T("03:tab\\btn_chat_talk_icon_03.png"), _T("04:tab\\btn_chat_talk_icon_recent.png")};

	for (int i = 0; i< 4; i++)	
	{
		int nFind = stringLine[i].Find(_T(":"));

		if (stringLine[i].IsEmpty() || nFind == -1)
			continue;

		CString strImgPath;
		strImgPath.Format(_T("%s\\sticker\\%s"), GetAppImgDir(), stringLine[i].Mid(nFind + 1));

		CString strImgPath1;
		strImgPath1 = strImgPath.Left(strImgPath.GetLength()-4);

		strImgPath1.Append(_T("_0.png"));

		if (!PathFileExists(strImgPath1))
			continue;

		CStickerGroupItem *pStickerGroup = new CStickerGroupItem();
		pStickerGroup->m_strGroupID = stringLine[i].Left(nFind);
		pStickerGroup->m_strImgPath[0] = strImgPath1;

		strImgPath1 = strImgPath.Left(strImgPath.GetLength()-4);

		strImgPath1.Append(_T("_1.png"));

		if (!PathFileExists(strImgPath1))
			pStickerGroup->m_strImgPath[1] = pStickerGroup->m_strImgPath[0];
        else
		  pStickerGroup->m_strImgPath[1] = strImgPath1;

		vecGroup->push_back(pStickerGroup);
	}
	return TRUE;
}
*/
// BOOL CClientConfig::SaveRecentUsedStickerInfo(RecentStickerVec* vecSticker){
// 
// 	if (vecSticker->size() < 1)
// 	{
// 		return FALSE;
// 	}
// 	CString strPath;
// 	strPath.Format(_T("%s\\recentSticker.dat"), GET_APP()->GetAppDataDir());
// 
// 	CStdioFile file;
// 
// 	if (file.Open(strPath, CFile::modeCreate) == 0)
// 		return FALSE;
//     file.Close();
// 	if (file.Open(strPath, CFile::modeWrite) == 0)
// 		return FALSE;
// 	CString strLine;
// 	int recentItem;
// 	for (RecentStickerVec ::iterator iter = vecSticker->begin();
// 		iter != vecSticker->end();
// 		++iter)
//    {
//      recentItem = (int)*iter;
// 	 strLine.Format(_T("%d:%d\n"),recentItem/1000,recentItem%1000);
// 	 file.WriteString(strLine);
//    }
// 	
// 	file.Close();
// 	return TRUE;
// }
// 
// 
// // The recent used format:
// // gid::sid; like 012:012_003
// BOOL CClientConfig::LoadRecentUsedStickerInfo(RecentStickerVec *recentStickerVec){
// 
// 	CString strPath;
// 	strPath.Format(_T("%s\\recentSticker.dat"), GET_APP()->GetAppDataDir());
// 
// 	CStdioFile file;
// 
// 	if (file.Open(strPath, CFile::modeRead ) == 0)
// 		return FALSE;
// 
// 	CString strLine;
// 
// 	while (file.ReadString(strLine))
// 	{
// 		int nFind = strLine.Find(_T(":"));
//      
// 		if (strLine.IsEmpty() || nFind == -1)
// 			continue;
// 
// 		
// 
// 		int m_strStickerID =_wtoi(strLine.Right(nFind)) ;
// 		int m_strGroupID =_wtoi(strLine.Left(nFind)) ;
// 		int RecentSticker = m_strGroupID * 1000 + m_strStickerID;
// 
// 
// 
// 		recentStickerVec->push_back(RecentSticker);
// 	}
// 
// 	file.Close();
// 
// 	return TRUE;
// }
// 
// 
// BOOL CClientConfig::LoadStickerInfo(std::vector<CStickerItem*> *vecSticker)
// {
// 	CString strPath;
// 	strPath.Format(_T("%s\\sticker.dat"), GET_APP()->GetAppDataDir());
// 
// 	CStdioFile file;
// 
// 	const int size = 82;
// 	CString m_StickerPath[size]={
// 
// 		//36
// 		_T("01_001:btn_chat_talk_sticker_01_01.png"),_T("01_002:btn_chat_talk_sticker_01_02.png"),_T("01_003:btn_chat_talk_sticker_01_03.png"),
// 		_T("01_004:btn_chat_talk_sticker_01_04.png"),_T("01_005:btn_chat_talk_sticker_01_05.png"),_T("01_006:btn_chat_talk_sticker_01_06.png"),
// 		_T("01_007:btn_chat_talk_sticker_01_07.png"),_T("01_008:btn_chat_talk_sticker_01_08.png"),_T("01_009:btn_chat_talk_sticker_01_09.png"),
// 		_T("01_010:btn_chat_talk_sticker_01_10.png"),_T("01_011:btn_chat_talk_sticker_01_11.png"),_T("01_012:btn_chat_talk_sticker_01_12.png"),
// 
// 		_T("02_001:btn_chat_talk_sticker_02_01.png"),_T("02_002:btn_chat_talk_sticker_02_02.png"),_T("02_003:btn_chat_talk_sticker_02_03.png"),
// 		_T("02_004:btn_chat_talk_sticker_02_04.png"),_T("02_005:btn_chat_talk_sticker_02_05.png"),_T("02_006:btn_chat_talk_sticker_02_06.png"),
// 		_T("02_007:btn_chat_talk_sticker_02_07.png"),_T("02_008:btn_chat_talk_sticker_02_08.png"),_T("02_009:btn_chat_talk_sticker_02_09.png"),
// 		_T("02_010:btn_chat_talk_sticker_02_10.png"),_T("02_011:btn_chat_talk_sticker_02_11.png"),_T("02_012:btn_chat_talk_sticker_02_12.png"),
// 
// 		_T("03_001:btn_chat_talk_sticker_03_01.png"),_T("03_002:btn_chat_talk_sticker_03_02.png"),_T("03_003:btn_chat_talk_sticker_03_03.png"),
// 		_T("03_004:btn_chat_talk_sticker_03_04.png"),_T("03_005:btn_chat_talk_sticker_03_05.png"),_T("03_006:btn_chat_talk_sticker_03_06.png"),
// 		_T("03_007:btn_chat_talk_sticker_03_07.png"),_T("03_008:btn_chat_talk_sticker_03_08.png"),_T("03_009:btn_chat_talk_sticker_03_09.png"),
// 		_T("03_010:btn_chat_talk_sticker_03_10.png"),_T("03_011:btn_chat_talk_sticker_03_11.png"),_T("03_012:btn_chat_talk_sticker_03_12.png"),
// 
// 		//20
// 		_T("05_001:img_sticker_d01_s.png"),_T("05_002:img_sticker_d02_s.png"),_T("05_003:img_sticker_d03_s.png"),
// 		_T("05_004:img_sticker_d04_s.png"),_T("05_005:img_sticker_d05_s.png"),
// 		_T("05_006:img_sticker_d06_s.png"),_T("05_007:img_sticker_d07_s.png"),_T("05_008:img_sticker_d08_s.png"),
// 		_T("05_009:img_sticker_d09_s.png"),_T("05_010:img_sticker_d10_s.png"),_T("05_011:img_sticker_d11_s.png"),
// 		_T("05_012:img_sticker_d12_s.png"),_T("05_013:img_sticker_d13_s.png"),_T("05_014:img_sticker_d14_s.png"),
// 		_T("05_015:img_sticker_d15_s.png"),_T("05_016:img_sticker_d16_s.png"),_T("05_017:img_sticker_d17_s.png"),
// 		_T("05_018:img_sticker_d18_s.png"),_T("05_019:img_sticker_d19_s.png"),_T("05_020:img_sticker_d20_s.png"),
// 
// 		//26
// 		_T("06_004:img_sticker_e04_s.png"),_T("06_005:img_sticker_e05_s.png"),
// 		_T("06_006:img_sticker_e06_s.png"),_T("06_007:img_sticker_e07_s.png"),_T("06_008:img_sticker_e08_s.png"),
// 		_T("06_009:img_sticker_e09_s.png"),_T("06_010:img_sticker_e10_s.png"),_T("06_011:img_sticker_e11_s.png"),
// 		_T("06_012:img_sticker_e12_s.png"),_T("06_013:img_sticker_e13_s.png"),_T("06_014:img_sticker_e14_s.png"),
// 		_T("06_015:img_sticker_e15_s.png"),_T("06_016:img_sticker_e16_s.png"),_T("06_017:img_sticker_e17_s.png"),
// 		_T("06_018:img_sticker_e18_s.png"),_T("06_019:img_sticker_e19_s.png"),_T("06_020:img_sticker_e20_s.png"),
// 		_T("06_021:img_sticker_e21_s.png"),
// 		_T("06_022:img_sticker_e22_s.png"),_T("06_023:img_sticker_e23_s.png"),_T("06_024:img_sticker_e24_s.png"),
// 		_T("06_025:img_sticker_e25_s.png"),_T("06_026:img_sticker_e26_s.png"),_T("06_027:img_sticker_e27_s.png"),
// 		_T("06_028:img_sticker_e28_s.png"),_T("06_029:img_sticker_e29_s.png")
// 	};
// 
// 	CString strLine;
// 	//if (file.Open(strPath, CFile::modeRead | CFile::shareDenyNone) == 0){
// 	   for (int i=0; i< size;i++)
// 	   {
// 		   strLine = m_StickerPath[i];
// 		   int nFind = strLine.Find(_T(":"));
// 
// 		   if (strLine.IsEmpty() || nFind == -1)
// 			   continue;
// 
// 
// 
// 
// 		   CStickerItem *pSticker = new CStickerItem();
// 		   pSticker->m_strStickerID = strLine.Left(nFind);
// 		   pSticker->m_sid = _wtoi(pSticker->m_strStickerID);
// 		   pSticker->m_strGroupID = _T("");
// 		   pSticker->m_gid = 0;
// 		   int nFindGroupDelimeter = pSticker->m_strStickerID.Find(_T("_"));
// 		   if (nFindGroupDelimeter > -1){
// 			   pSticker->m_strGroupID = pSticker->m_strStickerID.Left(nFindGroupDelimeter);
// 			   pSticker->m_gid = _wtoi(pSticker->m_strGroupID);
// 			   pSticker->m_sid = _wtoi(pSticker->m_strStickerID.Right(nFindGroupDelimeter));
// 
// 			   CString strImgPath;
// 			   strImgPath.Format(_T("%s\\sticker\\%02d\\%s"), GetAppImgDir(), pSticker->m_gid,strLine.Mid(nFind + 1));
// 
// 			   pSticker->m_strImgPath = strImgPath;       
// 
// 		   }
// 		   vecSticker->push_back(pSticker);
// 	   }	
// 		
// 		return FALSE;
// //	}
// 
// // 	while (file.ReadString(strLine))
// // 	{
// // 		int nFind = strLine.Find(_T(":"));
// // 
// // 		if (strLine.IsEmpty() || nFind == -1)
// // 			continue;
// // 
// // 		CString strImgPath;
// // 		strImgPath.Format(_T("%s\\sticker\\%s"), GetAppImgDir(), strLine.Mid(nFind + 1));
// // 		
// // 		
// // 
// // 		if (!PathFileExists(strImgPath))
// // 		{
// // 			strImgPath.Format(_T("%s\\sticker\\%s"), GetAppDUIImgDir(), strLine.Mid(nFind + 1));
// // 			if (!PathFileExists(strImgPath))
// // 			{
// // 				continue;
// // 			}
// // 			
// // 		}
// // 
// // 		CStickerItem *pSticker = new CStickerItem();
// // 		pSticker->m_strStickerID = strLine.Left(nFind);
// // 		pSticker->m_sid = _wtoi(pSticker->m_strStickerID);
// // 		pSticker->m_strImgPath = strImgPath;       
// //         pSticker->m_strGroupID = _T("");
// //         pSticker->m_gid = 0;
// // 		int nFindGroupDelimeter = pSticker->m_strStickerID.Find(_T("_"));
// // 		if (nFindGroupDelimeter > -1){
// // 			pSticker->m_strGroupID = pSticker->m_strStickerID.Left(nFindGroupDelimeter);
// //             pSticker->m_gid = _wtoi(pSticker->m_strGroupID);
// // 			pSticker->m_sid = _wtoi(pSticker->m_strStickerID.Right(nFindGroupDelimeter));
// // 
// // 		}
// // 		vecSticker->push_back(pSticker);
// // 	}
// // 
// // 	file.Close();
// 
// 	return TRUE;
// }

int CClientConfig::GetLanguage()
{
	return m_nLanguage;
}

int CClientConfig::GetAutoLogin()
{
	return m_nAutoLogin;
}

CString CClientConfig::GetSIP()
{
	return m_strSIP;
}

CString CClientConfig::GetSMTS()
{
	return m_strSMTS;
}

void CClientConfig::SetRecvFolder(const CString str)
{
	CSingleLock lock(&m_csRecvFolder);
	lock.Lock();

	m_strRecvFolder = str;

	CString strSavePath;
	strSavePath = GetClientConfigPath();
	WritePrivateProfileString(_T("ClientConfig"),_T("RecvFolder"), m_strRecvFolder, strSavePath);

	lock.Unlock();
}

void CClientConfig::SaveAutoText()
{
	CString strAutoTextFilePath;
	strAutoTextFilePath.Format(_T("%s\\autotext.ini"), GET_APP()->GetAppDataDir());

	CString strKey, strValue;

	// 상용구 개수
	strValue.Format(_T("%d"), m_vecAutoText.size());
	WritePrivateProfileString(_T("AutoText"), _T("AutoTextCount"), strValue, strAutoTextFilePath);

	for (size_t i = 0; i < m_vecAutoText.size(); i++)
	{
		strKey.Format(_T("%d"), i);

		strValue = m_vecAutoText[i];
		strValue.Replace(_T("\r"), _T("\\r"));
		strValue.Replace(_T("\n"), _T("\\n"));
		WritePrivateProfileString(_T("AutoText"), strKey, strValue, strAutoTextFilePath);
	}
}

void CClientConfig::LoadAutoText()
{
	CString strAutoTextFilePath;
	strAutoTextFilePath.Format(_T("%s\\autotext.ini"), GET_APP()->GetAppDataDir());

	CString strKey;
	TCHAR buf[2048] = {0,};

	int nAutoTextCount = GetPrivateProfileInt(_T("AutoText"),_T("AutoTextCount"), 20, strAutoTextFilePath);

	for (int i = 0; i < nAutoTextCount; i++)
	{
		strKey.Format(_T("%d"), i);
		memset(buf, 0, sizeof(buf));

		GetPrivateProfileString(_T("AutoText"), strKey, _T(""), buf, 2048, strAutoTextFilePath);

		CString strValue = buf;
		strValue.Replace(_T("\\r"), _T("\r"));
		strValue.Replace(_T("\\n"), _T("\n"));
		m_vecAutoText.push_back(strValue);
	}
}

void CClientConfig::SaveSearchLevel(const int nLevel)
{
	CString strSavePath;
	strSavePath = GetClientConfigPath();

	CString strLevel;
	strLevel.Format(_T("%d"), nLevel);
	WritePrivateProfileString(_T("ClientConfig"), _T("SearchLevel"), strLevel, strSavePath);
}

int CClientConfig::LoadSearchLevel()
{
	CString strLoadPath;
	strLoadPath = GetClientConfigPath();

	return GetPrivateProfileInt(_T("ClientConfig"), _T("SearchLevel"), 0, strLoadPath);
}

void CClientConfig::SetUpdateNoticeURL( CString str )
{
	m_strUpdateNoticeURL = str;
}

int CClientConfig::GetCopyNameDate()
{
	return 0;
	
	//disable CopyNameDate function
	//return m_nCopyNameDate;
}





